#include	"mapdefs.h"
#include	"stdio.h"
#include	"math.h"
#include	<X11/Xlib.h>
#include	<X11/Xutil.h>
#include	<X11/cursorfont.h>
#include	<X11/Intrinsic.h>

int		LRATIO;				/* Used in ndrv(); ratio of real to int sizes */
int		bdrymode;			/* Boundary modification mode */
int		normbdry;			/* Number of boundary circles. */
int		maxvars;			/* Maximum number of variable cnum fields */
int		runcount;			/* count number of converged runs */
int		subdividing;			/* flag to indicate continuation of acceleration */
Bool		massagemode;			/* flag for Thurston boundary modification */
Display		*dpy;				/* display device */
Window		domainwin, rangewin;		/* windows invoked */
GC		gc;				/* graphics context */
Region		myRegion;			/* bounding curves for the circle domain */
int		width, height;			/* dimensions of the circleinfo and plotinfo arrays */
int		hw;				/* (width-1)*(height-1) + 1*/
int		xmin, xmax, ymin, ymax;		/* bounding coordinates for myRegion */
int		numholes;			/* the number of holes in the circle domain */
int		numcircles;			/* the number of circles in the circle domain */
int		fixradi, fixradj;		/* circleinfo indices of a circle of fixed radius */
int		nulli, nullj;			/* circleinfo indices of the nullcircle */
double		fillrad;			/* filling radius */
double		maxkappa;			/* Maximum |curvature| */
circleinfo	*DCirc, *DHole, *RCirc, *RHole;		/* info of domain and range packings */
edgeinfo	*myedge;			/* edge information for prescribed angle intersections */
plotinfo	*DPlot, *RPlot;			/* info of domain and range screen plots */
XPoint		myRgnPoint[1000];		/* points determining the bounding curves for the circle domain */
int		normRgn;			/* the number of points in myRgnPoint */
int		*mycolor;			/* array of color pixel indices assigned to circles */
int		*myindex;			/* indices of nonzero circle entries */
int		mynorm;				/* length of myindex */
circleinfo	*GCirc, *GHole;			/* circle info used in making a better initial guess on a finer mesh */
int		oldwidth, oldheight;		/* dimensions of the circleinfo arrays before halving radius */

Bool		nullok();		/* Checks whether nullpoint is acceptable */
Bool		inside();		/* Checks whether a certain point is interior in the packing */
Bool		goodbdry();		/* Checks whether the boundary of the circle domain has been determined correctly for triangulation */
double		getxangle();		/* return angle assigned to a certain edge */
	
int		N;		/* the order of the linear system in the newton step */
double		*curvature;		/* vector of curvature values */

rowpartial	*myrow;			/* vector of partial derivatives of the curvature function; used in getkappa() */
double 		*phi, *d0phi, *d1phi;	/* summands of curvature and partial derivatives of curvature; used in getkappa() */
int		*mynum;			/* neighboring cnum indices; passed by getvalues() to getkappa() */
double 		*z;			/* neighboring radii; passed by getvalues() to getkappa() */

/* the following variables are used in the smpak subroutine NDRV */

int		*R, *C, *IC;	/* orderings on the Partial matrix; default to : i'th entry = i */
int		*IA;		/* delimit rows in JA and A; size = N+1 */
int		*JA;		/* column indices of nonzero entries in Partial */
double		 *A;		/* nonzero entries in Partial */
int		*ISP;		/* integer working storage; dimension = LRATIO*NSP */
double		*RSP;		/* work storage; ISP and RSP should be equivalenced (?) */
int		IAindex, IAsum, JAindex;

int		drawdomain_flag;

void		ndrv_(), nsf_(), nnf_();	/* Sparse matrix solvers */
